"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const getBitData_1 = require("./getBitData");
const medianFilter_1 = require("./medianFilter");
function getLines(data, width, height) {
    let bitData = getBitData_1.default(data, width, height);
    const lines = [];
    let count = 0;
    let columnAverageLast = 0;
    bitData = medianFilter_1.applyMedianFilter(bitData, width, height);
    for (let column = 0; column < width; column += 1) {
        let columnSum = 0;
        let columnAverage = 0;
        for (let row = 0; row < height; row += 1) {
            const index = row * width + column;
            columnSum += bitData[index];
        }
        // pixels are same in column
        columnAverage = columnSum / height >= 127 ? 255 : 0;
        // skip white padding in the start & end
        if (columnAverage === 255 && count === 0)
            continue;
        // count line width
        if (columnAverage === columnAverageLast) {
            count += 1;
        }
        else {
            lines.push(count);
            columnAverageLast = columnAverage;
            count = 1;
        }
        // skip padding in the last
        if (column === width - 1 && columnAverage === 0) {
            lines.push(count);
        }
    }
    return lines;
}
exports.getLines = getLines;
//# sourceMappingURL=getLines.js.map